diff --git a/lib/outputrenderers.php b/lib/outputrenderers.php
index 89b2423..d9b1966 100644
--- a/lib/outputrenderers.php
+++ b/lib/outputrenderers.php
@@ -3276,6 +3276,93 @@ EOD;
     }
 
     /**
+     * Construct the message tray, returning HTML that can be echoed out by a
+     * layout file.
+     *
+     * @param stdClass $user A user object, usually $USER.
+     * @return string HTML fragment.
+     */
+    public function message_tray($user = null) {
+        global $USER, $CFG, $DB;
+
+        if (is_null($user)) {
+            $user = $USER;
+        }
+
+        $returnstr = '';
+
+        // If during initial install, return the empty return string.
+        if (during_initial_install()) {
+            return $returnstr;
+        }
+
+        // If not logged in, return the empty return string.
+        if (!isloggedin()) {
+            return $returnstr;
+        }
+
+        // If logged in as a guest user, return the empty return string.
+        if (isguestuser()) {
+            return $returnstr;
+        }
+
+        // Check if messaging is enabled.
+        if (!$CFG->messaging) {
+            return $returnstr;
+        }
+
+        // Get message tray messages.
+        $messages = message_tray_get_messages();
+
+        foreach ($messages as $message) {
+            $image = html_writer::empty_tag('img', array('alt' => $message['name'], 'class' => 'media-object', 'src' => $message['img']));
+            $image = html_writer::tag('div', $image, array('class' => 'pull-left'));
+
+            $content = html_writer::tag('span', '', array('class' => $message['online'] ? 'status status-online' : 'status status-offline'));
+            $content .= ' ' . $message['name'];
+            $content = html_writer::tag('h4', $content, array('class' => 'media-heading'));
+            $content .= html_writer::tag('p', $message['message']);
+            $content .= html_writer::tag('small', $message['date'], array('class' => 'muted'));
+            $content = html_writer::tag('div', $content, array('class' => 'media-body'));
+
+            $media = $image . $content;
+            $media = html_writer::tag('a', $media, array('href' => '#'));
+            $media = html_writer::tag('li', $media, array('class' => $message['read'] ? 'media' : 'media active'));
+
+            $returnstr .= $media;
+        }
+
+        $returnstr = html_writer::tag('ul', $returnstr, array('class' => 'media-list'));
+        $returnstr = html_writer::tag('li', $returnstr);
+
+        $dropdownheader = html_writer::tag('li', get_string('messages', 'message'), array('class' => 'dropdown-header'));
+
+        $returnstr = $dropdownheader . $returnstr;
+
+        $dropdownfooter = html_writer::tag('a', get_string('gotomessages', 'message'), array('href' => $CFG->wwwroot.'/message/index.php'));
+        $dropdownfooter = html_writer::tag('li', $dropdownfooter, array('class' => 'dropdown-footer'));
+
+        $returnstr .= $dropdownfooter;
+
+        $returnstr = html_writer::tag('ul', $returnstr, array('class' => 'dropdown-menu'));
+
+        $dropdowntoggle = $this->pix_icon('t/message', get_string('messages', 'message'), 'moodle', array('class' => 'iconsmall'));
+
+        // Check notification count.
+        if ($countunread = message_count_unread_messages()) {
+            $dropdowntoggle .= html_writer::tag('span', $countunread, array('class' => 'badge badge-important'));
+        }
+
+        $dropdowntoggle = html_writer::tag('a', $dropdowntoggle, array('class' => 'dropdown-toggle', 'data-toggle' => 'dropdown', 'href' => '#'));
+
+        $returnstr = $dropdowntoggle . $returnstr;
+        $returnstr = html_writer::tag('li', $returnstr, array('class' => 'dropdown'));
+        $returnstr = html_writer::tag('ul', $returnstr, array('class' => 'nav pull-right', 'id' => 'message-tray'));
+
+        return $returnstr;
+    }
+
+    /**
      * Return the navbar content so that it can be echoed out by the layout
      *
      * @return string XHTML navbar
diff --git a/message/lib.php b/message/lib.php
index 92e06dd..08d77e6 100644
--- a/message/lib.php
+++ b/message/lib.php
@@ -2718,3 +2718,30 @@ function message_messenger_sendmessage_link_params($user) {
         'role' => 'button'
     );
 }
+
+/**
+ * Returns the current user's recent messages.
+ * TODO: pull data from Moodle.
+ *
+ * @param integer $limit Used to contrain the number of mesages returned.
+ * @return array Array of user's messages.
+ */
+function message_tray_get_messages($limit = 10) {
+    $users = json_decode(file_get_contents(sprintf('http://api.randomuser.me/?results=%d', $limit)));
+    $messages = array();
+
+    foreach ($users->results as $i => $result) {
+        $message = file_get_contents('http://www.iheartquotes.com/api/v1/random?max_lines=1&show_permalink=false&show_source=false');
+
+        $messages[] = array(
+            'read' => $i >= message_count_unread_messages(),
+            'img' => $result->user->picture->thumbnail,
+            'name' => ucwords($result->user->name->first . ' ' .$result->user->name->last),
+            'message' => $message,
+            'date' => date('M d'),
+            'online' => rand(0, 1) == 1
+        );
+    }
+
+    return $messages;
+}
diff --git a/theme/bootstrapbase/layout/columns1.php b/theme/bootstrapbase/layout/columns1.php
index 3494d90..13b863e 100644
--- a/theme/bootstrapbase/layout/columns1.php
+++ b/theme/bootstrapbase/layout/columns1.php
@@ -47,6 +47,7 @@ echo $OUTPUT->doctype() ?>
                 <span class="icon-bar"></span>
             </a>
             <?php echo $OUTPUT->user_menu(); ?>
+            <?php echo $OUTPUT->message_tray(); ?>
             <div class="nav-collapse collapse">
                 <?php echo $OUTPUT->custom_menu(); ?>
                 <ul class="nav pull-right">
diff --git a/theme/bootstrapbase/layout/columns2.php b/theme/bootstrapbase/layout/columns2.php
index e9fb50f..29d7038 100644
--- a/theme/bootstrapbase/layout/columns2.php
+++ b/theme/bootstrapbase/layout/columns2.php
@@ -56,6 +56,7 @@ echo $OUTPUT->doctype() ?>
                 <span class="icon-bar"></span>
             </a>
             <?php echo $OUTPUT->user_menu(); ?>
+            <?php echo $OUTPUT->message_tray(); ?>
             <div class="nav-collapse collapse">
                 <?php echo $OUTPUT->custom_menu(); ?>
                 <ul class="nav pull-right">
diff --git a/theme/bootstrapbase/layout/columns3.php b/theme/bootstrapbase/layout/columns3.php
index 5fcc80c..3269378 100644
--- a/theme/bootstrapbase/layout/columns3.php
+++ b/theme/bootstrapbase/layout/columns3.php
@@ -61,6 +61,7 @@ echo $OUTPUT->doctype() ?>
                 <span class="icon-bar"></span>
             </a>
             <?php echo $OUTPUT->user_menu(); ?>
+            <?php echo $OUTPUT->message_tray(); ?>
             <div class="nav-collapse collapse">
                 <?php echo $OUTPUT->custom_menu(); ?>
                 <ul class="nav pull-right">
diff --git a/theme/clean/layout/columns1.php b/theme/clean/layout/columns1.php
index 89e3f79..473e1f5 100644
--- a/theme/clean/layout/columns1.php
+++ b/theme/clean/layout/columns1.php
@@ -50,6 +50,7 @@ echo $OUTPUT->doctype() ?>
                 <span class="icon-bar"></span>
             </a>
             <?php echo $OUTPUT->user_menu(); ?>
+            <?php echo $OUTPUT->message_tray(); ?>
             <div class="nav-collapse collapse">
                 <?php echo $OUTPUT->custom_menu(); ?>
                 <ul class="nav pull-right">
diff --git a/theme/clean/layout/columns2.php b/theme/clean/layout/columns2.php
index 0818d57..d3f27c5 100644
--- a/theme/clean/layout/columns2.php
+++ b/theme/clean/layout/columns2.php
@@ -59,6 +59,7 @@ echo $OUTPUT->doctype() ?>
                 <span class="icon-bar"></span>
             </a>
             <?php echo $OUTPUT->user_menu(); ?>
+            <?php echo $OUTPUT->message_tray(); ?>
             <div class="nav-collapse collapse">
                 <?php echo $OUTPUT->custom_menu(); ?>
                 <ul class="nav pull-right">
diff --git a/theme/clean/layout/columns3.php b/theme/clean/layout/columns3.php
index 5053669..b83d0d0 100644
--- a/theme/clean/layout/columns3.php
+++ b/theme/clean/layout/columns3.php
@@ -69,6 +69,7 @@ echo $OUTPUT->doctype() ?>
                 <span class="icon-bar"></span>
             </a>
             <?php echo $OUTPUT->user_menu(); ?>
+            <?php echo $OUTPUT->message_tray(); ?>
             <div class="nav-collapse collapse">
                 <?php echo $OUTPUT->custom_menu(); ?>
                 <ul class="nav pull-right">
